<template>
  <div class="Ruler" :style="timelineWidth()">
    <div class="Ruler__Head">
      {{ t('page.weekPlanning.ruler.week') }} {{ week }}
    </div>
    <ol class="Ruler__Days">
      <NowBlock class="Ruler__Now" />
      <WeekendBlocks />
      <li
        v-for="day of days"
        :key="day.toISOString()"
        class="Ruler__Day"
        :style="style(day)"
      >
        <span class="Ruler__DayNumber">{{ day.format('DD') }}</span>
        <span class="Ruler__DayName">{{ day.format('ddd') }}</span>
        <span class="Ruler__DayMonth">{{ day.format('MMM') }}</span>
      </li>
    </ol>
  </div>
</template>

<script lang="ts" setup>
import { days, referenceDate } from '@/states/weekPlanning'
import { computed } from 'vue'
import moment from 'moment-timezone'
import { useI18n } from 'vue-i18n'
import { dateToPosition, timelineWidth } from './timedPosition'
import NowBlock from '@/pages/weekPlanning/NowBlock.vue'
import WeekendBlocks from '@/pages/weekPlanning/WeekendBlocks.vue'
import { Moment } from 'moment'
import { injectStrict } from '@/injectStrict'
import { ProvidedWeekPlanning, WeekPlanningKey } from '@/provided'

const { t } = useI18n()
const week = computed(() => moment(referenceDate.value).week())

const WeekPlanning = injectStrict<ProvidedWeekPlanning>(WeekPlanningKey)

function style(day: Moment) {
  const style = dateToPosition({ startDate: day.toDate() })
  style.width = `${
    (WeekPlanning.config.blockWidth * 24) / WeekPlanning.config.hoursPerBlock
  }px`
  return style
}
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use './weekPlanning' as wp;

.Ruler {
  @include wp.Timeline;

  position: sticky;
  top: 0;
  z-index: wp.$z-index-ruler;
  height: 40px;
  border-bottom: 1px solid var(--weekPlanning-border);
  background-color: var(--surface-0);

  &__Head {
    @include wp.TimeLineHead;

    border-bottom: none;
  }

  &__Days {
    @include wp.TimelineElements;

    background-color: var(--surface-0);
  }

  &__Day {
    position: absolute;
    display: grid;
    grid-template-areas:
      'number name'
      'month month';
    gap: v.$spacing-4;
    align-items: center;
    justify-content: start;
    overflow: hidden;
    height: 100%;
    padding-left: v.$spacing-4;
    border-left: 1px solid var(--weekPlanning-border);
    font-size: 0.8rem;
    text-transform: uppercase;

    &Number {
      grid-area: number;
    }

    &Month {
      grid-area: month;
    }

    &Name {
      grid-area: name;
    }
  }

  &__Now {
    border-bottom: 2px solid var(--success-color);
    background-color: transparent;
    opacity: 1;
  }
}
</style>
